require 'tk'

# Window drawing section.

font_name = "arial 10"

root = TkRoot.new() { title "TAX RATE GENERATOR" }
root.geometry('+12+100')

top_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x")

page_box_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>"left", :pady =>10, :padx=>5)

page_set_frame = TkFrame.new(page_box_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"top", :pady =>5, :padx=>5)

box_offset_frame = TkFrame.new(page_box_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"top", :pady =>5, :pady =>5, :padx=>5)

page_set_label = TkLabel.new(page_set_frame, :text=>"Page Number", :relief=>:sunken, :background=>"lightgrey", :width=>12, "font"=>font_name).pack(:side=>"left", :padx=>5, :pady=>5)

page_set = TkVariable.new
page_set_entry = TkEntry.new(page_set_frame, :textvariable=>page_set, :width=>10, "font"=>font_name).pack(:side=>"left", :padx=>5, :pady=>5)

box_offset_label = TkLabel.new(box_offset_frame, :text=>"Box Offset", :relief=>:sunken, :background=>"lightgrey", :width=>12, "font"=>font_name).pack(:side=>"left", :padx=>5, :pady=>5)

box_offset = TkVariable.new()
box_offset_entry = TkEntry.new(box_offset_frame, :textvariable=>box_offset, :width=>10, "font"=>font_name).pack(:side=>"left", :padx=>5, :pady=>5)

clear_page_box_button = TkButton.new(page_box_frame, :width=>22, :text=>"Clear Page / Box Values", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:padx=>10, :pady=>5)

clear_all_button = TkButton.new(page_box_frame, :width=>22, :text=>"Clear All Values", :background=>"lightgrey", :foreground=>"blue", "font"=>font_name).pack(:padx=>10, :pady=>5)

code_temp_filter_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>"left", :pady=>10, :padx=>5)

template_frame = TkFrame.new(code_temp_filter_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"top", :pady=>5, :padx=>5)

template_label = TkLabel.new(template_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Code Template", "font"=>font_name).pack(:fill=>:x)

code_template_frame = TkFrame.new(template_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :pady=>5, :padx=>5)

code_frame = TkFrame.new(code_template_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"top", :pady=>3, :padx=>3)

code_template_bar_vert = TkScrollbar.new(code_frame).pack(:side=>"right", :fill=>"y")
code_template_text = TkText.new(code_frame, "wrap"=>"none", :width=>60, "height"=>8, "font"=>font_name).pack("side"=>"left")
code_template_text.yscrollbar(code_template_bar_vert)

code_template_text.focus

clear_code_template_button = TkButton.new(code_template_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Clear Template", "font"=>font_name, "font"=>font_name, :width=>15).pack(:side=>"left", :pady=>5, :padx=>2)

compare_button = TkButton.new(code_template_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Compare", "font"=>font_name, "font"=>font_name, :width=>15).pack(:side=>"left", :pady=>5, :padx=>2)

generate_all_button = TkButton.new(code_template_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Generate All", "font"=>font_name, "font"=>font_name, :width=>15).pack(:side=>"left", :pady=>5, :padx=>2)

generate_changes_button = TkButton.new(code_template_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Generate Changes", "font"=>font_name, "font"=>font_name, :width=>15).pack(:side=>"left", :pady=>5, :padx=>2)

filter_frame = TkFrame.new(code_temp_filter_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :pady=>5, :padx=>5)

filter_label = TkLabel.new(filter_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Tax Rate Filter: Enter What You Want Removed From The Tax Rate Lists", "font"=>font_name).pack(:fill=>:x)

filter_text = TkText.new(filter_frame, "width"=>50, "height"=>1, "font"=>"arial 12 bold").pack(:padx=>5, :pady=>5)

clear_filter_button = TkButton.new(filter_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Clear Filter", "font"=>font_name, "font"=>font_name, :width=>16).pack(:side=>"left", :pady=>5, :padx=>2)

filter_prev_button = TkButton.new(filter_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Filter Previous", "font"=>font_name, "font"=>font_name, :width=>15).pack(:side=>"left", :pady=>5, :padx=>2)

filter_curr_button = TkButton.new(filter_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Filter Current", "font"=>font_name, "font"=>font_name, :width=>15).pack(:side=>"left", :pady=>5, :padx=>2)

filter_both_button = TkButton.new(filter_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Filter Both", "font"=>font_name, "font"=>font_name, :width=>16).pack(:side=>"right", :pady=>5, :padx=>2)

tax_rates_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :pady=>10, :padx=>5)

tax_rates_label = TkLabel.new(tax_rates_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Tax Rates", "font"=>font_name).pack(:fill=>:x)

prev_tax_rates_frame = TkFrame.new(tax_rates_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :pady=>5, :padx=>5)

prev_frame = TkFrame.new(prev_tax_rates_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"top", :pady=>3, :padx=>3)

curr_tax_rates_frame = TkFrame.new(tax_rates_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :pady=>5, :padx=>5)

curr_frame = TkFrame.new(curr_tax_rates_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"top", :pady=>3, :padx=>3)

prev_label = TkLabel.new(prev_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Previous", "font"=>font_name).pack(:fill=>:x)

curr_label = TkLabel.new(curr_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Current", "font"=>font_name).pack(:fill=>:x)

prev_tax_rates_bar_vert = TkScrollbar.new(prev_frame).pack(:side=>"right", :fill=>"y")
prev_tax_rates_text = TkText.new(prev_frame, "wrap"=>"none", "width"=>8, "height"=>15, "font"=>font_name).pack("side"=>"left")
prev_tax_rates_text.yscrollbar(prev_tax_rates_bar_vert)

clear_prev_button = TkButton.new(prev_tax_rates_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Clear List", "font"=>font_name, "font"=>font_name).pack(:pady=>5)

curr_tax_rates_bar_vert = TkScrollbar.new(curr_frame).pack(:side=>"right", :fill=>"y")
curr_tax_rates_text = TkText.new(curr_frame, "wrap"=>"none", "width"=>8, "height"=>15, "font"=>font_name).pack("side"=>"left")
curr_tax_rates_text.yscrollbar(curr_tax_rates_bar_vert)

clear_curr_button = TkButton.new(curr_tax_rates_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Clear List", "font"=>font_name, "font"=>font_name).pack(:pady=>5)

output_frame = TkFrame.new(root, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "fill"=>"both", "expand"=>true, :pady =>10, :padx=>5)

output_label = TkLabel.new(output_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Generated Tax Rate Code - NOTE: ' Ctrl-/ ' selects all text.", "font"=>font_name).pack("fill"=>"x")

out_text_frame = TkFrame.new(output_frame).pack("side"=>"left", "fill"=>"both", "expand"=>true)
out_text_bar_vert = TkScrollbar.new(out_text_frame).pack("side"=>"right", "fill"=>"y")
out_text = TkText.new(out_text_frame,"width"=>113, "height"=>20, "font"=>font_name).pack("side"=>"bottom", "fill"=>"both", "expand"=>true)

out_text.yscrollbar(out_text_bar_vert)

#
# Action section.
#

clear_code_template_button.bind("Button-1") { code_template_text.delete("1.0", "end") }
clear_prev_button.bind("Button-1") { prev_tax_rates_text.delete("1.0", "end") }
clear_curr_button.bind("Button-1") { curr_tax_rates_text.delete("1.0", "end") }
clear_filter_button.bind("Button-1") { filter_text.delete("1.0", "end") }

filter_prev_button.bind("Button-1") {

	prev_array = Array.new

	#
	# Filter the filter text characters from the previous tax rates array, removing
	# any empty array slots after the filtration, then redisplay the filtered tax rate list.
	#
	prev_array = prev_tax_rates_text.get("1.0", "end").split
	prev_array.each { |rate| rate.delete!(filter_text.get("1.0", "end")) }
	prev_array.delete("")
	prev_tax_rates_text.delete("1.0", "end")

	#
	# Doing the each_index way so that we do not append a newline char to the end of the
	# last list element, this way there is no blank space being displayed.
	#
	prev_array.each_index { |index| prev_tax_rates_text.insert("end", "#{prev_array[index]}#{(index < prev_array.length - 1 ? "\n" : "")}") }
	}

filter_curr_button.bind("Button-1") {

	curr_array = Array.new

	#
	# Filter the filter text characters from the current tax rates array, removing
	# any empty array slots after the filtration, then redisplay the filtered tax rate list.
	#
	curr_array = curr_tax_rates_text.get("1.0", "end").split
	curr_array.each { |rate| rate.delete!(filter_text.get("1.0", "end")) }
	curr_array.delete("")
	curr_tax_rates_text.delete("1.0", "end")

	#
	# Doing the each_index way so that we do not append a newline char to the end of the
	# last list element, this way there is no blank space being displayed.
	#
	curr_array.each_index { |index| curr_tax_rates_text.insert("end", "#{curr_array[index]}#{(index < curr_array.length - 1 ? "\n" : "")}") }
	}

filter_both_button.bind("Button-1") {

	curr_array = Array.new
	prev_array = Array.new

	#
	# Filter the filter text characters from the current tax rates array, removing
	# any empty array slots after the filtration, then redisplay the filtered tax rate list.
	#
	curr_array = curr_tax_rates_text.get("1.0", "end").split
	curr_array.each { |rate| rate.delete!(filter_text.get("1.0", "end")) }
	curr_array.delete("")
	curr_tax_rates_text.delete("1.0", "end")

	#
	# Doing the each_index way so that we do not append a newline char to the end of the
	# last list element, this way there is no blank space being displayed.
	#
	curr_array.each_index { |index| curr_tax_rates_text.insert("end", "#{curr_array[index]}#{(index < curr_array.length - 1 ? "\n" : "")}") }

	#
	# Filter the filter text characters from the previous tax rates array, removing
	# any empty array slots after the filtration, then redisplay the filtered tax rate list.
	#
	prev_array = prev_tax_rates_text.get("1.0", "end").split
	prev_array.each { |rate| rate.delete!(filter_text.get("1.0", "end")) }
	prev_array.delete("")
	prev_tax_rates_text.delete("1.0", "end")

	#
	# Doing the each_index way so that we do not append a newline char to the end of the
	# last list element, this way there is no blank space being displayed.
	#
	prev_array.each_index { |index| prev_tax_rates_text.insert("end", "#{prev_array[index]}#{(index < prev_array.length - 1 ? "\n" : "")}") }
	}

clear_page_box_button.bind("Button-1") {
	page_set.value = ''
	box_offset.value = ''
	}

clear_all_button.bind("Button-1") {
	page_set.value = ''
	box_offset.value = ''
	code_template_text.delete("1.0", "end")
	filter_text.delete("1.0", "end")
	prev_tax_rates_text.delete("1.0", "end")
	curr_tax_rates_text.delete("1.0", "end")
	}

compare_button.bind("Button-1") {

	prev_array = Array.new
	curr_array = Array.new

	#
	# These are TK tags, used in displaying regions of text in various colors for visual impact.
	#
	out_text.tag_configure("message", :background=>"blue", :foreground=>"white", :font=>"arial 12 bold")
	out_text.tag_configure("changed", :background=>"green", :foreground=>"black", :font=>"arial 12 bold")
	out_text.tag_configure("added", :background=>"magenta", :foreground=>"black", :font=>"arial 12 bold")
	out_text.tag_configure("deleted", :background=>"cyan", :foreground=>"black", :font=>"arial 12 bold")

	prev_tax_rates_text.tag_configure("changed", :background=>"green", :foreground=>"black")
	prev_tax_rates_text.tag_configure("deleted", :background=>"cyan", :foreground=>"black")

	curr_tax_rates_text.tag_configure("changed", :background=>"green", :foreground=>"black")
	curr_tax_rates_text.tag_configure("added", :background=>"magenta", :foreground=>"black")

	#
	# Setup for the compare operation:
	#
	out_text.delete("1.0", "end")
	prev_tax_rates_text.tag_remove("changed", "1.0", "end")
	prev_tax_rates_text.tag_remove("deleted", "1.0", "end")
	curr_tax_rates_text.tag_remove("changed", "1.0", "end")
	curr_tax_rates_text.tag_remove("added", "1.0", "end")

	prev_array = prev_tax_rates_text.get("1.0", "end").split
	curr_array = curr_tax_rates_text.get("1.0", "end").split

	size_diff = 0
	change_cnt = 0
	msg_str = ''

	if (prev_array != curr_array)

		size_diff = 	(curr_array.length - prev_array.length)

		curr_array.each_index { |index|

			if (index > prev_array.length - 1)

				#
				# The current rate array is larger than the previous rate array, so just
				# highlight the extra array value.
				#
				curr_tax_rates_text.tag_add("added", "#{index + 1}.0", "#{index + 1}.end")
			else

				#
				# Need to compare array entries at index.
				#
				if (prev_array[index] != curr_array[index])

					change_cnt += 1
					prev_tax_rates_text.tag_add("changed", "#{index + 1}.0", "#{index + 1}.end")
					curr_tax_rates_text.tag_add("changed", "#{index + 1}.0", "#{index + 1}.end")
				end
			end
		}

		#
		# Being anal here, just to stay consistent - highlighting those previous rates that have been removed,
		# that is, highlight the end of the previous rate array if the current rate array is shorter.
		#
		if (prev_array.length > curr_array.length)
			curr_array.length.upto(prev_array.length - 1) { |index|
				prev_tax_rates_text.tag_add("deleted", "#{index + 1}.0", "#{index + 1}.end")
			}
		end
	end

	if (change_cnt > 0)

		out_text.insert("end", " *** #{change_cnt} RATE#{(change_cnt > 1 ? "S HAVE" : " HAS")} CHANGED - SEE ", "message")
		out_text.insert("end", "HIGHLIGHTED", "changed")
		out_text.insert("end", " LIST ELEMENTS FOR CHANGES *** \n", "message")
	else

		out_text.insert("end", " *** NO RATE HAS CHANGED *** \n", "message")
	end

	out_text.insert("end", "\n")

	out_text.insert("end", " *** NEW RATE ARRAY HAS ", "message")

	if (size_diff != 0)

		out_text.insert("end", "DECREASED", "deleted") if (size_diff < 0)
		out_text.insert("end", "INCREASED", "added") if (size_diff > 0)
		out_text.insert("end", " IN SIZE BY #{size_diff.abs} RATE#{(size_diff.abs > 1 ? "S" : "")} *** \n", "message")
	else
		out_text.insert("end", "NOT CHANGED IN SIZE *** \n", "message") 
	end
}

def rate_convert(raw_rate)

	#
	# Currently handling NY, WA, and SD sales tax forms, this will most likely need adjusting
	# as we cover more forms and run into "wierd" stuff along the way.
	#
	case
		when (raw_rate =~ /\A(\d*)((\d)(\/)(\d+))?(%)\Z/)

			#
			# We have a rate expressed as a percent, possibly using fractions.
			#
			# New York State forms can be like this.
			#
			rate = (($1.to_f + (($3 and $5) ? $3.to_f / $5.to_f : 0.0)) / 100.0).to_s

		when (raw_rate =~ /\A\.\d+\Z/)

			#
			# We have a rate expressed as a decimal with nothing to the left of the decimal point.
			# We need to put a zero to the left of the decimal to keep Ruby happy.
			#
			# Washington State forms can be like this.
			#
			rate = "0#{raw_rate}"

		when (raw_rate =~ /\A(\d+)(\.)(\d+)(%)\Z/)

			#
			# We have a rate expressed as a percent using decimals - e.g. "1.95%"
			#
			# South Dakota forms can be like this.
			#
			rate = ((raw_rate.delete("%").to_f) / 100.0).to_s

		else

			#
			# Use it whatever it is, just as it is.
			#
			rate = raw_rate
	end

	return rate
end

generate_all_button.bind("Button-1") {

	out_text.delete("1.0", "end")

	#
	# Run through the entire current tax rate list and generate code using the template.
	# Decimals and percents are handled. Boxes are numbered as follows:
	#
	# If the "Page Number" field has a value, then the page portion of the box number
	# is set to that value. This stays the same for all generated code. The FIRST iteration
	# uses the box numbering in the template, remaining iterations use the "Box Offset" value.
	#
	curr_array = Array.new

	curr_array = curr_tax_rates_text.get("1.0", "end").split
	input_str = code_template_text.get("1.0", "end")
	offset_box = box_offset.to_s.to_i

	curr_array.each_index { |index|

		rate = rate_convert(curr_array[index])

		input_str.each { |code_line|

			#
			# First adjust the box numbering.
			#
			code_line.gsub!(/(box)(\d+)(_)(\d+)/) { |box|

				num = $4.to_i

				#
				# Increment the box number. Note that the page number is not
				# incremented, only the box number portion.
				#
				num += offset_box * index

				#
				# Prepare the box token for re-insertion back into the string.
				#
				$1 + (page_set.to_s.empty? ? $2 : page_set.to_s) + $3 + num.to_s
			}

			#
			# Now set the tax rate portion. Looking for a space char followed by a float, this way we
			# do not incorrectly interpret "box2_56 = '%0.0f' % ( box2_55.to_f * 0.005 )" the format string
			# as a float, we want the "0.005" and we never will have "*0.005", but will have a space char between
			# the "*" and the "0.005". Using gsub so that we will keep looking in the line for a float. This will
			# need to be changed if two floats are ever encountered, else all of them will be changed. Note that
			# we do not want to lose the space, so we are doing " #{rate}".
			#
			code_line.gsub!(/ \d+\.\d+/, " #{rate}")
			out_text.insert("end", code_line)
		}
	}

	out_text.focus
	out_text.mark_set("insert", "1.0")
}

generate_changes_button.bind("Button-1") {

	out_text.delete("1.0", "end")

#~ out_text.insert("end", "#{code_template_text.tag_ranges("sel")}\n")
#~ out_text.insert("end", "#{curr_tax_rates_text.tag_ranges("changed")}\n")
#~ out_text.insert("end", "#{curr_tax_rates_text.tag_ranges("added")}\n")

	#
	# These are TK tags, used in displaying regions of text in various colors for visual impact.
	#
	out_text.tag_configure("error", :background=>"red", :foreground=>"white", :font=>"arial 12 bold")

	#
	# Run through the entire current tax rate list and generate code using the template.
	# Decimals and percents are handled. Boxes are numbered as follows:
	#
	# If the "Page Number" field has a value, then the page portion of the box number
	# is set to that value. This stays the same for all generated code. The FIRST iteration
	# uses the box numbering in the template, remaining iterations use the "Box Offset" value.
	#
	curr_array = Array.new
	change_array = Array.new

	curr_array = curr_tax_rates_text.get("1.0", "end").split
	change_array = curr_tax_rates_text.tag_ranges("changed")
	change_array = change_array.concat(curr_tax_rates_text.tag_ranges("added"))
	input_str = code_template_text.get("1.0", "end")
	offset_box = box_offset.to_s.to_i

	#
	# The change array is a two dimensional array.
	#
	change_array.each { |change|

		if (change[0] =~ /(\d+)(\.)/)

			#
			# Processing only the changed rates which also includes any extra rates. The ranges are expressed as
			# "2.02.5" which means the second line in the text list, starting at the first character and ending at
			# the fifth. Note the line numbering starts at 1 not 0, so we need to decrement by 1 to lineup with the
			# array indices.
			#
			change_index = $1.to_i - 1
			rate = rate_convert(curr_array[change_index])
	
			input_str.each { |code_line|
	
				#
				# First adjust the box numbering.
				#
				code_line.gsub!(/(box)(\d+)(_)(\d+)/) { |box|
	
					num = $4.to_i
	
					#
					# Increment the box number. Note that the page number is not
					# incremented, only the box number portion.
					#
					num += offset_box * change_index
	
					#
					# Prepare the box token for re-insertion back into the string.
					#
					$1 + (page_set.to_s.empty? ? $2 : page_set.to_s) + $3 + num.to_s
				}
	
				#
				# Now set the tax rate portion. Looking for a space char followed by a float, this way we
				# do not incorrectly interpret "box2_56 = '%0.0f' % ( box2_55.to_f * 0.005 )" the format string
				# as a float, we want the "0.005" and we never will have "*0.005", but will have a space char between
				# the "*" and the "0.005". Using gsub so that we will keep looking in the line for a float. This will
				# need to be changed if two floats are ever encountered, else all of them will be changed. Note that
				# we do not want to lose the space, so we are doing " #{rate}".
				#
				code_line.gsub!(/ \d+\.\d+/, " #{rate}")
				out_text.insert("end", code_line)
			}
		else

			#
			# Something went wrong with the change_array.
			#
			out_text.insert("end", "BAD CHANGE ARRAY VALUE: #{change}", "error")
		end
	}

	out_text.focus
	out_text.mark_set("insert", "1.0")
}

Tk.mainloop()
